



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Lazy Scheduler</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Lazy Scheduler</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 20:25:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1><a href="http://www.cnblogs.com/deepleo/p/LazyScheduler.html" rel="external nofollow noreferrer">Lazy Scheduler：我的轻量级任务调度框架</a></h1>
<div>&nbsp;</div>
<div>
<div>
<p><strong>一、背景</strong></p>
<p>工作中经常涉及任务调度，一直都是采用while(true) =&gt; if hitted DO =&gt; Thread.Sleep(interval)的模式。但是最近实在是感觉这种实现模式很挫。并且没有考虑到性能问题，需要撞击n次才能命中一次，使用效率不足5%（一百次while循环命中不到5次），但是单方面加大线程睡眠时间又无法保证高准确性和高精度。那有么有其它好的思路：即可以保持高准确性、高精度，又不浪费资源呢？</p>
<p><strong>&nbsp;二、我的思路</strong></p>
<p>上述的短板在于：无目的的线程Sleep，如果我们可以每次恰到好处的Sleep，即线程被唤醒后刚好赶上下一次的任务到来，命中率就是100%了嘛。所以可以这样做：进入While后先按照Scheduler计算出下次的运行时间距离现在还有多久(Interval)，然后直接Sleep(Interval)，等待线程唤醒后就立即执行下一个既定Task就可以了。那这样做唯一的难点就在于你的Scheduler是否可计算、是否可以计算出下一次的运行时间点。</p>
<p>还好，我碰到的逻辑都还是满足这一点需求的：</p>
<p>（1）每隔一段时间执行一次的计划任务；</p>
<p>（2）在指定时间点必须执行的计划任务;</p>
<p>其他人性化设定：周六周日不运行。</p>
<p><strong>三、代码实现</strong></p>
<p>（1）主要有：负责调度的接口：IScheduler；Scheduler设定:ISchedulerSetting;任务接口：ITask以及一些其他的辅助类。<br /><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/274849/201311/02142148-b238a1a48be0412299515507ca727a3c.jpg" /></p>
<p>（2）难点:计算Interval的实现类：FixTimeSchedulerSetting.cs和IntervalSchedulerSetting.cs</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
<div>16</div>
<div>17</div>
<div>18</div>
<div>19</div>
<div>20</div>
<div>21</div>
<div>22</div>
<div>23</div>
<div>24</div>
<div>25</div>
<div>26</div>
<div>27</div>
<div>28</div>
<div>29</div>
<div>30</div>
<div>31</div>
<div>32</div>
<div>33</div>
<div>34</div>
<div>35</div>
<div>36</div>
<div>37</div>
<div>38</div>
<div>39</div>
<div>40</div>
<div>41</div>
<div>42</div>
<div>43</div>
<div>44</div>
<div>45</div>
<div>46</div>
<div>47</div>
<div>48</div>
<div>49</div>
<div>50</div>
<div>51</div>
<div>52</div>
<div>53</div>
<div>54</div>
<div>55</div>
<div>56</div>
<div>57</div>
<div>58</div>
<div>59</div>
<div>60</div>
<div>61</div>
</td>
<td>
<div>
<div><code>//Author:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; night-king</code></div>
<div><code>// Email:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; deepleo@163.com</code></div>
<div><code>//Home:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href="http://deepleo.com/" rel="external nofollow noreferrer">http://deepleo.com</a></code></div>
<div><code>//Github:&nbsp;&nbsp;&nbsp;&nbsp; <a href="https://github.com/night-king/" rel="external nofollow noreferrer">https://github.com/night-king/</a></code></div>
<div><code>//Date:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2013-11-1 </code></div>
<div><code>//Place:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Wuhan@China</code></div>
<div>&nbsp;</div>
<div><code>using</code>&nbsp;<code>System;</code></div>
<div><code>using</code>&nbsp;<code>System.Collections.Generic;</code></div>
<div><code>using</code>&nbsp;<code>System.Text;</code></div>
<div><code>using</code>&nbsp;<code>System.Collections;</code></div>
<div>&nbsp;</div>
<div><code>namespace</code>&nbsp;<code>Deepleo.LazyScheduler.Setting</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>class</code>&nbsp;<code>FixTimeSchedulerSetting : IFixTimeSchedulerSetting, IWeekSchedulerSetting</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>IList&lt;DayOfWeek&gt; ExcludeWeeks</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>get</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>set</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>int</code>&nbsp;<code>Hour</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>get</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>set</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>int</code>&nbsp;<code>Minutes</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>get</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>set</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>int</code>&nbsp;<code>Second</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>get</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>set</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>FixTimeSchedulerSetting(IList&lt;DayOfWeek&gt; excludeWeeks)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ExcludeWeeks = excludeWeeks;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>virtual</code>&nbsp;<code>TimeSpan CalculateNext()</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>nowDateTime = System.DateTime.Now;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>expectNextTime = System.DateTime.Parse(</code><code>string</code><code>.Format(</code><code>"{0}-{1}-{2} {3}:{4}:{5}"</code><code>, nowDateTime.Year, nowDateTime.Month, nowDateTime.Day, Hour, Minutes, Second));</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>todayWeek = nowDateTime.DayOfWeek;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>km = </code><code>new</code>&nbsp;<code>WeekManager(ExcludeWeeks);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>delayDays = km.CalculateDelayDays(todayWeek);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(delayDays == 0)</code><code>// this day of week can do</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(expectNextTime &gt; nowDateTime) </code><code>return</code>&nbsp;<code>expectNextTime - nowDateTime;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>else</code>&nbsp;<code>delayDays++;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>expectNextTime.AddDays(delayDays) - nowDateTime;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>　　</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
<div>16</div>
<div>17</div>
<div>18</div>
<div>19</div>
<div>20</div>
<div>21</div>
<div>22</div>
<div>23</div>
<div>24</div>
<div>25</div>
<div>26</div>
<div>27</div>
<div>28</div>
<div>29</div>
<div>30</div>
<div>31</div>
<div>32</div>
<div>33</div>
<div>34</div>
<div>35</div>
<div>36</div>
<div>37</div>
<div>38</div>
</td>
<td>
<div>
<div><code>using</code>&nbsp;<code>System;</code></div>
<div><code>using</code>&nbsp;<code>System.Collections.Generic;</code></div>
<div><code>using</code>&nbsp;<code>System.Text;</code></div>
<div>&nbsp;</div>
<div><code>namespace</code>&nbsp;<code>Deepleo.LazyScheduler.Setting</code></div>
<div><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>class</code>&nbsp;<code>IntervalSchedulerSetting : IIntervalSchedulerSetting, IWeekSchedulerSetting</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>TimeSpan Interval</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>get</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>set</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>IList&lt;DayOfWeek&gt; ExcludeWeeks</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>get</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>set</code><code>;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>IntervalSchedulerSetting(IList&lt;DayOfWeek&gt; excludeWeeks)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>ExcludeWeeks = excludeWeeks;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>TimeSpan CalculateNext()</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>nowDateTime = System.DateTime.Now;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>todayWeek =nowDateTime.DayOfWeek;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>km = </code><code>new</code>&nbsp;<code>WeekManager(ExcludeWeeks);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>delayDays = km.CalculateDelayDays(todayWeek);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>interval = Interval.Add(</code><code>new</code>&nbsp;<code>TimeSpan(delayDays, 0, 0, 0));</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(interval.CompareTo(</code><code>new</code>&nbsp;<code>TimeSpan(0, 0, 1)) &lt;= 0) </code><code>return</code>&nbsp;<code>new</code>&nbsp;<code>TimeSpan(0, 0, 1);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>else</code>&nbsp;<code>return</code>&nbsp;<code>interval;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p>重要的辅助类：WeekManager的实现代码：</p>
<div>
<div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
<div>16</div>
<div>17</div>
<div>18</div>
<div>19</div>
<div>20</div>
<div>21</div>
<div>22</div>
<div>23</div>
<div>24</div>
<div>25</div>
<div>26</div>
<div>27</div>
<div>28</div>
<div>29</div>
<div>30</div>
<div>31</div>
<div>32</div>
<div>33</div>
<div>34</div>
<div>35</div>
<div>36</div>
<div>37</div>
<div>38</div>
<div>39</div>
<div>40</div>
<div>41</div>
<div>42</div>
<div>43</div>
<div>44</div>
<div>45</div>
<div>46</div>
<div>47</div>
<div>48</div>
<div>49</div>
<div>50</div>
<div>51</div>
<div>52</div>
<div>53</div>
<div>54</div>
<div>55</div>
<div>56</div>
<div>57</div>
<div>58</div>
<div>59</div>
<div>60</div>
<div>61</div>
</td>
<td>
<div>
<div><code>//Author:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; night-king</code></div>
<div><code>// Email:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; deepleo@163.com</code></div>
<div><code>//Home:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href="http://deepleo.com/" rel="external nofollow noreferrer">http://deepleo.com</a></code></div>
<div><code>//Github:&nbsp;&nbsp;&nbsp;&nbsp; <a href="https://github.com/night-king/" rel="external nofollow noreferrer">https://github.com/night-king/</a></code></div>
<div><code>//Date:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 2013-11-1 </code></div>
<div><code>//Place:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Wuhan@China</code></div>
<div>&nbsp;</div>
<div><code>using</code>&nbsp;<code>System;</code></div>
<div><code>using</code>&nbsp;<code>System.Collections.Generic;</code></div>
<div><code>using</code>&nbsp;<code>System.Text;</code></div>
<div>&nbsp;</div>
<div><code>namespace</code>&nbsp;<code>Deepleo.LazyScheduler.Setting</code></div>
<div><code>{</code></div>
<div><code>&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>class</code>&nbsp;<code>WeekManager</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>private</code>&nbsp;<code>Dictionary&lt;</code><code>int</code><code>, DayOfWeek&gt; _allowWeekDict;</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>WeekManager(IList&lt;DayOfWeek&gt; notAllowWeeks)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict = </code><code>new</code>&nbsp;<code>Dictionary&lt;</code><code>int</code><code>, DayOfWeek&gt;();</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(!notAllowWeeks.Contains(DayOfWeek.Sunday))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict.Add(0, DayOfWeek.Sunday);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(!notAllowWeeks.Contains(DayOfWeek.Monday))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict.Add(1, DayOfWeek.Monday);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(!notAllowWeeks.Contains(DayOfWeek.Tuesday))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict.Add(2, DayOfWeek.Tuesday);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(!notAllowWeeks.Contains(DayOfWeek.Wednesday))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict.Add(3, DayOfWeek.Wednesday);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(!notAllowWeeks.Contains(DayOfWeek.Thursday))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict.Add(4, DayOfWeek.Thursday);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(!notAllowWeeks.Contains(DayOfWeek.Friday))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict.Add(5, DayOfWeek.Friday);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(!notAllowWeeks.Contains(DayOfWeek.Saturday))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>_allowWeekDict.Add(6, DayOfWeek.Saturday);</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>/// &lt;summary&gt;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>/// Calcute how many delay days</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>/// &lt;/summary&gt;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>/// &lt;param name="week"&gt;current day of week&lt;/param&gt;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>/// &lt;returns&gt;delay days&lt;/returns&gt;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>public</code>&nbsp;<code>int</code>&nbsp;<code>CalculateDelayDays(DayOfWeek week)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code>&nbsp;<code>weekOfDay = (</code><code>int</code><code>)week;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>int</code>&nbsp;<code>distence = 0;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>while</code>&nbsp;<code>(</code><code>true</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(_allowWeekDict.ContainsKey(weekOfDay))</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>distence;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>else</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>weekOfDay = weekOfDay &lt; 6 ? weekOfDay + 1 : 0;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>distence++;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<p><strong>四、测试</strong></p>
<p>(1)5s钟时间间隔的测试结果：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/274849/201311/02142314-f6557414c95d43299eff64651592d08c.jpg" /></p>
<p>（2）1s测试结果：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/274849/201311/02143124-5bfd44b13deb4efa8dccb26d7dd3d1bf.jpg" /></p>
<p>再看CPU占用情况：</p>
<p><img referrerpolicy="no-referrer"src="http://images.cnitblog.com/blog/274849/201311/02143256-3d2663566ef74a889b06dd92bededab9.jpg" /></p>
<p>基本上稳定在0%，内存占用也只有6.4k.</p>
<p><strong>五、代码下载：</strong></p>
<p><a href="http://files.cnblogs.com/deepleo/SchedulerSolution.zip" rel="external nofollow noreferrer"><strong>http://files.cnblogs.com/deepleo/SchedulerSolution.zip</strong></a></p>
<p><a href="https://github.com/night-king/LazyScheduler" rel="external nofollow noreferrer">https://github.com/night-king/LazyScheduler</a></p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4prejq.html">linux-磁盘空间（du-df）</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gy3j79.html">mysql语句中有引号的问题解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96wwdjq.html">Linux应用领域</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eg72m9.html">hihoCode 1078 &colon; 线段树的区间修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1537z9.html">Java WEB &mdash;&mdash; XML</a>
		</li>
						<li><a href="https://www.batexi.com/a/96od6xv9.html">debian root用户在shell下如何能够使用颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okwdr59.html">&lbrack;jquery&rsqb; jQuery点滴&lbrack;持续更新&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm3k3e9.html">高效算法&mdash;&mdash;C 分饼</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0wz0gq.html">C&plus;&plus;程序设计实践指导1&period;13自然数集中找合数改写要求实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z0ln69.html">Linux系统编程（6）&mdash;&mdash;文件系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkdd3d8.html">【百度地图API1&period;1】修改文本标注的样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jk7rw8.html">ZOJ 3702&Tab;Gibonacci number</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z71m09.html">python3中的编码与解码用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rlvn58.html">权限框架Apache Shiro 和 Spring Security</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r56gx7q.html">『TensorFlow』从磁盘读取数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wrp2nq.html">条件随机场之CRF&plus;&plus;源码详解-训练</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1ln5e9.html">转&colon;Ogre源代码浅析&mdash;&mdash;脚本及其解析（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pmwrnq.html">棋盘状态压缩dp</a>
		</li>
						<li><a href="https://www.batexi.com/a/953w4ov8.html">利用HBuilder打包前端开发webapp为apk</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emw00k9.html">CGA填充算法之种子填充算法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9geen2e8.html">查询出各个学科的前3名的同学信息的Sql</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j5dxx8.html">Unity该插件NGUI学习（1）&mdash;&mdash; 环境结构</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zoxpe9.html">纠错《COM技术内幕》之ProgID</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mrvm48.html">XMLHttpRequest创建对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j5jlv8.html">nginx 开展对RT5350</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpwpnxq.html">【转】Appium基于安卓的各种FindElement的控件定位方法实践</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj11n5q.html">Ubuntu 12&period;04 64bit  安装编译GCC 4&period;1&period;2 绝对原创</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1yy22q.html">linux系统管理命令--系统测试工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj141lq.html">mysql 千分位 Format</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoyvovq.html">代理模式与Android</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
